xref: /titanic_41/usr/src/tools/scripts/nightly.sh (revision b59b3655028aeb11832ad679eb5c2577c2b75235)
1#!/bin/ksh -p
2#
3# CDDL HEADER START
4#
5# The contents of this file are subject to the terms of the
6# Common Development and Distribution License (the "License").
7# You may not use this file except in compliance with the License.
8#
9# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
10# or http://www.opensolaris.org/os/licensing.
11# See the License for the specific language governing permissions
12# and limitations under the License.
13#
14# When distributing Covered Code, include this CDDL HEADER in each
15# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
16# If applicable, add the following below this CDDL HEADER, with the
17# fields enclosed by brackets "[]" replaced with your own identifying
18# information: Portions Copyright [yyyy] [name of copyright owner]
19#
20# CDDL HEADER END
21#
22
23#
24# Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
25# Copyright 2008, 2010, Richard Lowe
26# Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
27# Copyright 2012 Joshua M. Clulow <josh@sysmgr.org>
28#
29# Based on the nightly script from the integration folks,
30# Mostly modified and owned by mike_s.
31# Changes also by kjc, dmk.
32#
33# BRINGOVER_WS may be specified in the env file.
34# The default is the old behavior of CLONE_WS
35#
36# -i on the command line, means fast options, so when it's on the
37# command line (only), lint and check builds are skipped no matter what
38# the setting of their individual flags are in NIGHTLY_OPTIONS.
39#
40# LINTDIRS can be set in the env file, format is a list of:
41#
42#	/dirname-to-run-lint-on flag
43#
44#	Where flag is:	y - enable lint noise diff output
45#			n - disable lint noise diff output
46#
47#	For example: LINTDIRS="$SRC/uts n $SRC/stand y $SRC/psm y"
48#
49# OPTHOME  may be set in the environment to override /opt
50#
51
52#
53# The CDPATH variable causes ksh's `cd' builtin to emit messages to stdout
54# under certain circumstances, which can really screw things up; unset it.
55#
56unset CDPATH
57
58# Get the absolute path of the nightly script that the user invoked.  This
59# may be a relative path, and we need to do this before changing directory.
60nightly_path=`whence $0`
61
62#
63# Keep track of where we found nightly so we can invoke the matching
64# which_scm script.  If that doesn't work, don't go guessing, just rely
65# on the $PATH settings, which will generally give us either /opt/onbld
66# or the user's workspace.
67#
68WHICH_SCM=$(dirname $nightly_path)/which_scm
69if [[ ! -x $WHICH_SCM ]]; then
70	WHICH_SCM=which_scm
71fi
72
73function fatal_error
74{
75	print -u2 "nightly: $*"
76	exit 1
77}
78
79#
80# Function to do a DEBUG and non-DEBUG build. Needed because we might
81# need to do another for the source build, and since we only deliver DEBUG or
82# non-DEBUG packages.
83#
84# usage: normal_build
85#
86function normal_build {
87
88	typeset orig_p_FLAG="$p_FLAG"
89	typeset crypto_signer="$CODESIGN_USER"
90
91	suffix=""
92
93	# non-DEBUG build begins
94
95	if [ "$F_FLAG" = "n" ]; then
96		set_non_debug_build_flags
97		CODESIGN_USER="$crypto_signer" \
98		    build "non-DEBUG" "$suffix-nd" "-nd" "$MULTI_PROTO"
99	else
100		echo "\n==== No non-DEBUG $open_only build ====\n" >> "$LOGFILE"
101	fi
102
103	# non-DEBUG build ends
104
105	# DEBUG build begins
106
107	if [ "$D_FLAG" = "y" ]; then
108		set_debug_build_flags
109		CODESIGN_USER="$crypto_signer" \
110		    build "DEBUG" "$suffix" "" "$MULTI_PROTO"
111	else
112		echo "\n==== No DEBUG $open_only build ====\n" >> "$LOGFILE"
113	fi
114
115	# DEBUG build ends
116
117	p_FLAG="$orig_p_FLAG"
118}
119
120#
121# usage: run_hook HOOKNAME ARGS...
122#
123# If variable "$HOOKNAME" is defined, insert a section header into
124# our logs and then run the command with ARGS
125#
126function run_hook {
127	HOOKNAME=$1
128    	eval HOOKCMD=\$$HOOKNAME
129	shift
130
131	if [ -n "$HOOKCMD" ]; then
132	    	(
133			echo "\n==== Running $HOOKNAME command: $HOOKCMD ====\n"
134		    	( $HOOKCMD "$@" 2>&1 )
135			if [ "$?" -ne 0 ]; then
136			    	# Let exit status propagate up
137			    	touch $TMPDIR/abort
138			fi
139		) | tee -a $mail_msg_file >> $LOGFILE
140
141		if [ -f $TMPDIR/abort ]; then
142			build_ok=n
143			echo "\nAborting at request of $HOOKNAME" |
144				tee -a $mail_msg_file >> $LOGFILE
145			exit 1
146		fi
147	fi
148}
149
150# Return library search directive as function of given root.
151function myldlibs {
152	echo "-L$1/lib -L$1/usr/lib"
153}
154
155# Return header search directive as function of given root.
156function myheaders {
157	echo "-I$1/usr/include"
158}
159
160#
161# Function to do the build, including package generation.
162# usage: build LABEL SUFFIX ND MULTIPROTO
163# - LABEL is used to tag build output.
164# - SUFFIX is used to distinguish files (e.g., DEBUG vs non-DEBUG,
165#   open-only vs full tree).
166# - ND is "-nd" (non-DEBUG builds) or "" (DEBUG builds).
167# - If MULTIPROTO is "yes", it means to name the proto area according to
168#   SUFFIX.  Otherwise ("no"), (re)use the standard proto area.
169#
170function build {
171	LABEL=$1
172	SUFFIX=$2
173	ND=$3
174	MULTIPROTO=$4
175	INSTALLOG=install${SUFFIX}-${MACH}
176	NOISE=noise${SUFFIX}-${MACH}
177	PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
178
179	ORIGROOT=$ROOT
180	[ $MULTIPROTO = no ] || export ROOT=$ROOT$SUFFIX
181
182	export ENVLDLIBS1=`myldlibs $ROOT`
183	export ENVCPPFLAGS1=`myheaders $ROOT`
184
185	this_build_ok=y
186	#
187	#	Build OS-Networking source
188	#
189	echo "\n==== Building OS-Net source at `date` ($LABEL) ====\n" \
190		>> $LOGFILE
191
192	rm -f $SRC/${INSTALLOG}.out
193	cd $SRC
194	/bin/time $MAKE -e install 2>&1 | \
195	    tee -a $SRC/${INSTALLOG}.out >> $LOGFILE
196
197	echo "\n==== Build errors ($LABEL) ====\n" >> $mail_msg_file
198	egrep ":" $SRC/${INSTALLOG}.out |
199		egrep -e "(^${MAKE}:|[ 	]error[: 	\n])" | \
200		egrep -v "Ignoring unknown host" | \
201		egrep -v "cc .* -o error " | \
202		egrep -v "warning" | tee $TMPDIR/build_errs${SUFFIX} \
203		>> $mail_msg_file
204	if [[ -s $TMPDIR/build_errs${SUFFIX} ]]; then
205		build_ok=n
206		this_build_ok=n
207	fi
208	grep "bootblock image is .* bytes too big" $SRC/${INSTALLOG}.out \
209		>> $mail_msg_file
210	if [ "$?" = "0" ]; then
211		build_ok=n
212		this_build_ok=n
213	fi
214
215	echo "\n==== Build warnings ($LABEL) ====\n" >>$mail_msg_file
216	egrep -i warning: $SRC/${INSTALLOG}.out \
217		| egrep -v '^tic:' \
218		| egrep -v "symbol (\`|')timezone' has differing types:" \
219		| egrep -v "parameter <PSTAMP> set to" \
220		| egrep -v "Ignoring unknown host" \
221		| egrep -v "redefining segment flags attribute for" \
222		| tee $TMPDIR/build_warnings${SUFFIX} >> $mail_msg_file
223	if [[ -s $TMPDIR/build_warnings${SUFFIX} ]]; then
224		build_ok=n
225		this_build_ok=n
226	fi
227
228	echo "\n==== Ended OS-Net source build at `date` ($LABEL) ====\n" \
229		>> $LOGFILE
230
231	echo "\n==== Elapsed build time ($LABEL) ====\n" >>$mail_msg_file
232	tail -3  $SRC/${INSTALLOG}.out >>$mail_msg_file
233
234	if [ "$i_FLAG" = "n" ]; then
235		rm -f $SRC/${NOISE}.ref
236		if [ -f $SRC/${NOISE}.out ]; then
237			mv $SRC/${NOISE}.out $SRC/${NOISE}.ref
238		fi
239		grep : $SRC/${INSTALLOG}.out \
240			| egrep -v '^/' \
241			| egrep -v '^(Start|Finish|real|user|sys|./bld_awk)' \
242			| egrep -v '^tic:' \
243			| egrep -v '^mcs' \
244			| egrep -v '^LD_LIBRARY_PATH=' \
245			| egrep -v 'ar: creating' \
246			| egrep -v 'ar: writing' \
247			| egrep -v 'conflicts:' \
248			| egrep -v ':saved created' \
249			| egrep -v '^stty.*c:' \
250			| egrep -v '^mfgname.c:' \
251			| egrep -v '^uname-i.c:' \
252			| egrep -v '^volumes.c:' \
253			| egrep -v '^lint library construction:' \
254			| egrep -v 'tsort: INFORM:' \
255			| egrep -v 'stripalign:' \
256			| egrep -v 'chars, width' \
257			| egrep -v "symbol (\`|')timezone' has differing types:" \
258			| egrep -v 'PSTAMP' \
259			| egrep -v '|%WHOANDWHERE%|' \
260			| egrep -v '^Manifying' \
261			| egrep -v 'Ignoring unknown host' \
262			| egrep -v 'Processing method:' \
263			| egrep -v '^Writing' \
264			| egrep -v 'spellin1:' \
265			| egrep -v '^adding:' \
266			| egrep -v "^echo 'msgid" \
267			| egrep -v '^echo ' \
268			| egrep -v '\.c:$' \
269			| egrep -v '^Adding file:' \
270			| egrep -v 'CLASSPATH=' \
271			| egrep -v '\/var\/mail\/:saved' \
272			| egrep -v -- '-DUTS_VERSION=' \
273			| egrep -v '^Running Mkbootstrap' \
274			| egrep -v '^Applet length read:' \
275			| egrep -v 'bytes written:' \
276			| egrep -v '^File:SolarisAuthApplet.bin' \
277			| egrep -v -i 'jibversion' \
278			| egrep -v '^Output size:' \
279			| egrep -v '^Solo size statistics:' \
280			| egrep -v '^Using ROM API Version' \
281			| egrep -v '^Zero Signature length:' \
282			| egrep -v '^Note \(probably harmless\):' \
283			| egrep -v '::' \
284			| egrep -v -- '-xcache' \
285			| egrep -v '^\+' \
286			| egrep -v '^cc1: note: -fwritable-strings' \
287			| egrep -v 'svccfg-native -s svc:/' \
288			| sort | uniq >$SRC/${NOISE}.out
289		if [ ! -f $SRC/${NOISE}.ref ]; then
290			cp $SRC/${NOISE}.out $SRC/${NOISE}.ref
291		fi
292		echo "\n==== Build noise differences ($LABEL) ====\n" \
293			>>$mail_msg_file
294		diff $SRC/${NOISE}.ref $SRC/${NOISE}.out >>$mail_msg_file
295	fi
296
297	#
298	#	Re-sign selected binaries using signing server
299	#	(gatekeeper builds only)
300	#
301	if [ -n "$CODESIGN_USER" -a "$this_build_ok" = "y" ]; then
302		echo "\n==== Signing proto area at `date` ====\n" >> $LOGFILE
303		signing_file="${TMPDIR}/signing"
304		rm -f ${signing_file}
305		export CODESIGN_USER
306		signproto $SRC/tools/codesign/creds 2>&1 | \
307			tee -a ${signing_file} >> $LOGFILE
308		echo "\n==== Finished signing proto area at `date` ====\n" \
309		    >> $LOGFILE
310		echo "\n==== Crypto module signing errors ($LABEL) ====\n" \
311		    >> $mail_msg_file
312		egrep 'WARNING|ERROR' ${signing_file} >> $mail_msg_file
313		if (( $? == 0 )) ; then
314			build_ok=n
315			this_build_ok=n
316		fi
317	fi
318
319	#
320	#	Building Packages
321	#
322	if [ "$p_FLAG" = "y" -a "$this_build_ok" = "y" ]; then
323		if [ -d $SRC/pkg ]; then
324			echo "\n==== Creating $LABEL packages at `date` ====\n" \
325				>> $LOGFILE
326			echo "Clearing out $PKGARCHIVE ..." >> $LOGFILE
327			rm -rf $PKGARCHIVE >> "$LOGFILE" 2>&1
328			mkdir -p $PKGARCHIVE >> "$LOGFILE" 2>&1
329
330			rm -f $SRC/pkg/${INSTALLOG}.out
331			cd $SRC/pkg
332			/bin/time $MAKE -e install 2>&1 | \
333			    tee -a $SRC/pkg/${INSTALLOG}.out >> $LOGFILE
334
335			echo "\n==== package build errors ($LABEL) ====\n" \
336				>> $mail_msg_file
337
338			egrep "${MAKE}|ERROR|WARNING" $SRC/pkg/${INSTALLOG}.out | \
339				grep ':' | \
340				grep -v PSTAMP | \
341				egrep -v "Ignoring unknown host" | \
342				tee $TMPDIR/package >> $mail_msg_file
343			if [[ -s $TMPDIR/package ]]; then
344				build_extras_ok=n
345				this_build_ok=n
346			fi
347		else
348			#
349			# Handle it gracefully if -p was set but there so
350			# no pkg directory.
351			#
352			echo "\n==== No $LABEL packages to build ====\n" \
353				>> $LOGFILE
354		fi
355	else
356		echo "\n==== Not creating $LABEL packages ====\n" >> $LOGFILE
357	fi
358
359	ROOT=$ORIGROOT
360}
361
362# Usage: dolint /dir y|n
363# Arg. 2 is a flag to turn on/off the lint diff output
364function dolint {
365	if [ ! -d "$1" ]; then
366		echo "dolint error: $1 is not a directory"
367		exit 1
368	fi
369
370	if [ "$2" != "y" -a "$2" != "n" ]; then
371		echo "dolint internal error: $2 should be 'y' or 'n'"
372		exit 1
373	fi
374
375	lintdir=$1
376	dodiff=$2
377	base=`basename $lintdir`
378	LINTOUT=$lintdir/lint-${MACH}.out
379	LINTNOISE=$lintdir/lint-noise-${MACH}
380	export ENVLDLIBS1=`myldlibs $ROOT`
381	export ENVCPPFLAGS1=`myheaders $ROOT`
382
383	set_debug_build_flags
384
385	#
386	#	'$MAKE lint' in $lintdir
387	#
388	echo "\n==== Begin '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
389
390	# remove old lint.out
391	rm -f $lintdir/lint.out $lintdir/lint-noise.out
392	if [ -f $lintdir/lint-noise.ref ]; then
393		mv $lintdir/lint-noise.ref ${LINTNOISE}.ref
394	fi
395
396	rm -f $LINTOUT
397	cd $lintdir
398	#
399	# Remove all .ln files to ensure a full reference file
400	#
401	rm -f Nothing_to_remove \
402	    `find . \( -name SCCS -o -name .hg -o -name .svn -o -name .git \) \
403	    	-prune -o -type f -name '*.ln' -print `
404
405	/bin/time $MAKE -ek lint 2>&1 | \
406	    tee -a $LINTOUT >> $LOGFILE
407
408	echo "\n==== '$MAKE lint' of $base ERRORS ====\n" >> $mail_msg_file
409
410	grep "$MAKE:" $LINTOUT |
411		egrep -v "Ignoring unknown host" | \
412		tee $TMPDIR/lint_errs >> $mail_msg_file
413	if [[ -s $TMPDIR/lint_errs ]]; then
414		build_extras_ok=n
415	fi
416
417	echo "\n==== Ended '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
418
419	echo "\n==== Elapsed time of '$MAKE lint' of $base ====\n" \
420		>>$mail_msg_file
421	tail -3  $LINTOUT >>$mail_msg_file
422
423	rm -f ${LINTNOISE}.ref
424	if [ -f ${LINTNOISE}.out ]; then
425		mv ${LINTNOISE}.out ${LINTNOISE}.ref
426	fi
427        grep : $LINTOUT | \
428		egrep -v '^(real|user|sys)' |
429		egrep -v '(library construction)' | \
430		egrep -v ': global crosschecks' | \
431		egrep -v 'Ignoring unknown host' | \
432		egrep -v '\.c:$' | \
433		sort | uniq > ${LINTNOISE}.out
434	if [ ! -f ${LINTNOISE}.ref ]; then
435		cp ${LINTNOISE}.out ${LINTNOISE}.ref
436	fi
437
438	if [ "$dodiff" != "n" ]; then
439		echo "\n==== lint warnings $base ====\n" \
440			>>$mail_msg_file
441		# should be none, though there are a few that were filtered out
442		# above
443		egrep -i '(warning|lint):' ${LINTNOISE}.out \
444			| sort | uniq | tee $TMPDIR/lint_warns >> $mail_msg_file
445		if [[ -s $TMPDIR/lint_warns ]]; then
446			build_extras_ok=n
447		fi
448		echo "\n==== lint noise differences $base ====\n" \
449			>> $mail_msg_file
450		diff ${LINTNOISE}.ref ${LINTNOISE}.out \
451			>> $mail_msg_file
452	fi
453}
454
455#
456# Build and install the onbld tools.
457#
458# usage: build_tools DESTROOT
459#
460# returns non-zero status if the build was successful.
461#
462function build_tools {
463	DESTROOT=$1
464
465	INSTALLOG=install-${MACH}
466
467	echo "\n==== Building tools at `date` ====\n" \
468		>> $LOGFILE
469
470	rm -f ${TOOLS}/${INSTALLOG}.out
471	cd ${TOOLS}
472	/bin/time $MAKE TOOLS_PROTO=${DESTROOT} -e install 2>&1 | \
473	    tee -a ${TOOLS}/${INSTALLOG}.out >> $LOGFILE
474
475	echo "\n==== Tools build errors ====\n" >> $mail_msg_file
476
477	egrep ":" ${TOOLS}/${INSTALLOG}.out |
478		egrep -e "(${MAKE}:|[ 	]error[: 	\n])" | \
479		egrep -v "Ignoring unknown host" | \
480		egrep -v warning | tee $TMPDIR/tools_errors >> $mail_msg_file
481
482	if [[ -s $TMPDIR/tools_errors ]]; then
483		return 1
484	fi
485	return 0
486}
487
488#
489# Set up to use locally installed tools.
490#
491# usage: use_tools TOOLSROOT
492#
493function use_tools {
494	TOOLSROOT=$1
495
496	#
497	# If we're not building ON workspace, then the TOOLSROOT
498	# settings here are clearly ignored by the workspace
499	# makefiles, prepending nonexistent directories to PATH is
500	# harmless, and we clearly do not wish to override
501	# ONBLD_TOOLS.
502	#
503	# If we're building an ON workspace, then the prepended PATH
504	# elements should supercede the preexisting ONBLD_TOOLS paths,
505	# and we want to override ONBLD_TOOLS to catch the tools that
506	# don't have specific path env vars here.
507	#
508	# So the only conditional behavior is overriding ONBLD_TOOLS,
509	# and we check for "an ON workspace" by looking for
510	# ${TOOLSROOT}/opt/onbld.
511	#
512
513	STABS=${TOOLSROOT}/opt/onbld/bin/${MACH}/stabs
514	export STABS
515	CTFSTABS=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfstabs
516	export CTFSTABS
517	GENOFFSETS=${TOOLSROOT}/opt/onbld/bin/genoffsets
518	export GENOFFSETS
519
520	CTFCONVERT=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfconvert
521	export CTFCONVERT
522	CTFMERGE=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfmerge
523	export CTFMERGE
524
525	CTFCVTPTBL=${TOOLSROOT}/opt/onbld/bin/ctfcvtptbl
526	export CTFCVTPTBL
527	CTFFINDMOD=${TOOLSROOT}/opt/onbld/bin/ctffindmod
528	export CTFFINDMOD
529
530	if [ "$VERIFY_ELFSIGN" = "y" ]; then
531		ELFSIGN=${TOOLSROOT}/opt/onbld/bin/elfsigncmp
532	else
533		ELFSIGN=${TOOLSROOT}/opt/onbld/bin/${MACH}/elfsign
534	fi
535	export ELFSIGN
536
537	PATH="${TOOLSROOT}/opt/onbld/bin/${MACH}:${PATH}"
538	PATH="${TOOLSROOT}/opt/onbld/bin:${PATH}"
539	export PATH
540
541	if [ -d "${TOOLSROOT}/opt/onbld" ]; then
542		ONBLD_TOOLS=${TOOLSROOT}/opt/onbld
543		export ONBLD_TOOLS
544	fi
545
546	echo "\n==== New environment settings. ====\n" >> $LOGFILE
547	echo "STABS=${STABS}" >> $LOGFILE
548	echo "CTFSTABS=${CTFSTABS}" >> $LOGFILE
549	echo "CTFCONVERT=${CTFCONVERT}" >> $LOGFILE
550	echo "CTFMERGE=${CTFMERGE}" >> $LOGFILE
551	echo "CTFCVTPTBL=${CTFCVTPTBL}" >> $LOGFILE
552	echo "CTFFINDMOD=${CTFFINDMOD}" >> $LOGFILE
553	echo "ELFSIGN=${ELFSIGN}" >> $LOGFILE
554	echo "PATH=${PATH}" >> $LOGFILE
555	echo "ONBLD_TOOLS=${ONBLD_TOOLS}" >> $LOGFILE
556}
557
558function staffer {
559	if [ $ISUSER -ne 0 ]; then
560		"$@"
561	else
562		arg="\"$1\""
563		shift
564		for i
565		do
566			arg="$arg \"$i\""
567		done
568		eval su $STAFFER -c \'$arg\'
569	fi
570}
571
572#
573# Verify that the closed bins are present
574#
575function check_closed_bins {
576	if [[ ! -d "$ON_CLOSED_BINS" ]]; then
577		echo "ON_CLOSED_BINS must point to the closed binaries tree."
578		build_ok=n
579		exit 1
580	fi
581}
582
583#
584# wrapper over wsdiff.
585# usage: do_wsdiff LABEL OLDPROTO NEWPROTO
586#
587function do_wsdiff {
588	label=$1
589	oldproto=$2
590	newproto=$3
591
592	wsdiff="wsdiff"
593	[ "$t_FLAG" = y ] && wsdiff="wsdiff -t"
594
595	echo "\n==== Getting object changes since last build at `date`" \
596	    "($label) ====\n" | tee -a $LOGFILE >> $mail_msg_file
597	$wsdiff -s -r ${TMPDIR}/wsdiff.results $oldproto $newproto 2>&1 | \
598		    tee -a $LOGFILE >> $mail_msg_file
599	echo "\n==== Object changes determined at `date` ($label) ====\n" | \
600	    tee -a $LOGFILE >> $mail_msg_file
601}
602
603#
604# Functions for setting build flags (DEBUG/non-DEBUG).  Keep them
605# together.
606#
607
608function set_non_debug_build_flags {
609	export RELEASE_BUILD ; RELEASE_BUILD=
610	unset EXTRA_OPTIONS
611	unset EXTRA_CFLAGS
612}
613
614function set_debug_build_flags {
615	unset RELEASE_BUILD
616	unset EXTRA_OPTIONS
617	unset EXTRA_CFLAGS
618}
619
620
621MACH=`uname -p`
622
623if [ "$OPTHOME" = "" ]; then
624	OPTHOME=/opt
625	export OPTHOME
626fi
627
628USAGE='Usage: nightly [-in] [+t] [-V VERS ] <env_file>
629
630Where:
631	-i	Fast incremental options (no clobber, lint, check)
632	-n      Do not do a bringover
633	+t	Use the build tools in $ONBLD_TOOLS/bin
634	-V VERS set the build version string to VERS
635
636	<env_file>  file in Bourne shell syntax that sets and exports
637	variables that configure the operation of this script and many of
638	the scripts this one calls. If <env_file> does not exist,
639	it will be looked for in $OPTHOME/onbld/env.
640
641non-DEBUG is the default build type. Build options can be set in the
642NIGHTLY_OPTIONS variable in the <env_file> as follows:
643
644	-A	check for ABI differences in .so files
645	-C	check for cstyle/hdrchk errors
646	-D	do a build with DEBUG on
647	-F	do _not_ do a non-DEBUG build
648	-G	gate keeper default group of options (-au)
649	-I	integration engineer default group of options (-ampu)
650	-M	do not run pmodes (safe file permission checker)
651	-N	do not run protocmp
652	-R	default group of options for building a release (-mp)
653	-U	update proto area in the parent
654	-V VERS set the build version string to VERS
655	-f	find unreferenced files
656	-i	do an incremental build (no "make clobber")
657	-l	do "make lint" in $LINTDIRS (default: $SRC y)
658	-m	send mail to $MAILTO at end of build
659	-n      do not do a bringover
660	-p	create packages
661	-r	check ELF runtime attributes in the proto area
662	-t	build and use the tools in $SRC/tools (default setting)
663	+t	Use the build tools in $ONBLD_TOOLS/bin
664	-u	update proto_list_$MACH and friends in the parent workspace;
665		when used with -f, also build an unrefmaster.out in the parent
666	-w	report on differences between previous and current proto areas
667'
668#
669#	A log file will be generated under the name $LOGFILE
670#	for partially completed build and log.`date '+%F'`
671#	in the same directory for fully completed builds.
672#
673
674# default values for low-level FLAGS; G I R are group FLAGS
675A_FLAG=n
676C_FLAG=n
677D_FLAG=n
678F_FLAG=n
679f_FLAG=n
680i_FLAG=n; i_CMD_LINE_FLAG=n
681l_FLAG=n
682M_FLAG=n
683m_FLAG=n
684N_FLAG=n
685n_FLAG=n
686p_FLAG=n
687r_FLAG=n
688t_FLAG=y
689U_FLAG=n
690u_FLAG=n
691V_FLAG=n
692w_FLAG=n
693W_FLAG=n
694#
695build_ok=y
696build_extras_ok=y
697
698#
699# examine arguments
700#
701
702OPTIND=1
703while getopts +intV:W FLAG
704do
705	case $FLAG in
706	  i )	i_FLAG=y; i_CMD_LINE_FLAG=y
707		;;
708	  n )	n_FLAG=y
709		;;
710	 +t )	t_FLAG=n
711		;;
712	  V )	V_FLAG=y
713		V_ARG="$OPTARG"
714		;;
715	  W )   W_FLAG=y
716		;;
717	 \? )	echo "$USAGE"
718		exit 1
719		;;
720	esac
721done
722
723# correct argument count after options
724shift `expr $OPTIND - 1`
725
726# test that the path to the environment-setting file was given
727if [ $# -ne 1 ]; then
728	echo "$USAGE"
729	exit 1
730fi
731
732# check if user is running nightly as root
733# ISUSER is set non-zero if an ordinary user runs nightly, or is zero
734# when root invokes nightly.
735/usr/bin/id | grep '^uid=0(' >/dev/null 2>&1
736ISUSER=$?;	export ISUSER
737
738#
739# force locale to C
740LANG=C;		export LANG
741LC_ALL=C;	export LC_ALL
742LC_COLLATE=C;	export LC_COLLATE
743LC_CTYPE=C;	export LC_CTYPE
744LC_MESSAGES=C;	export LC_MESSAGES
745LC_MONETARY=C;	export LC_MONETARY
746LC_NUMERIC=C;	export LC_NUMERIC
747LC_TIME=C;	export LC_TIME
748
749# clear environment variables we know to be bad for the build
750unset LD_OPTIONS
751unset LD_AUDIT		LD_AUDIT_32		LD_AUDIT_64
752unset LD_BIND_NOW	LD_BIND_NOW_32		LD_BIND_NOW_64
753unset LD_BREADTH	LD_BREADTH_32		LD_BREADTH_64
754unset LD_CONFIG		LD_CONFIG_32		LD_CONFIG_64
755unset LD_DEBUG		LD_DEBUG_32		LD_DEBUG_64
756unset LD_DEMANGLE	LD_DEMANGLE_32		LD_DEMANGLE_64
757unset LD_FLAGS		LD_FLAGS_32		LD_FLAGS_64
758unset LD_LIBRARY_PATH	LD_LIBRARY_PATH_32	LD_LIBRARY_PATH_64
759unset LD_LOADFLTR	LD_LOADFLTR_32		LD_LOADFLTR_64
760unset LD_NOAUDIT	LD_NOAUDIT_32		LD_NOAUDIT_64
761unset LD_NOAUXFLTR	LD_NOAUXFLTR_32		LD_NOAUXFLTR_64
762unset LD_NOCONFIG	LD_NOCONFIG_32		LD_NOCONFIG_64
763unset LD_NODIRCONFIG	LD_NODIRCONFIG_32	LD_NODIRCONFIG_64
764unset LD_NODIRECT	LD_NODIRECT_32		LD_NODIRECT_64
765unset LD_NOLAZYLOAD	LD_NOLAZYLOAD_32	LD_NOLAZYLOAD_64
766unset LD_NOOBJALTER	LD_NOOBJALTER_32	LD_NOOBJALTER_64
767unset LD_NOVERSION	LD_NOVERSION_32		LD_NOVERSION_64
768unset LD_ORIGIN		LD_ORIGIN_32		LD_ORIGIN_64
769unset LD_PRELOAD	LD_PRELOAD_32		LD_PRELOAD_64
770unset LD_PROFILE	LD_PROFILE_32		LD_PROFILE_64
771
772unset CONFIG
773unset GROUP
774unset OWNER
775unset REMOTE
776unset ENV
777unset ARCH
778unset CLASSPATH
779unset NAME
780
781#
782# To get ONBLD_TOOLS from the environment, it must come from the env file.
783# If it comes interactively, it is generally TOOLS_PROTO, which will be
784# clobbered before the compiler version checks, which will therefore fail.
785#
786unset ONBLD_TOOLS
787
788#
789#	Setup environmental variables
790#
791if [ -f /etc/nightly.conf ]; then
792	. /etc/nightly.conf
793fi
794
795if [ -f $1 ]; then
796	if [[ $1 = */* ]]; then
797		. $1
798	else
799		. ./$1
800	fi
801else
802	if [ -f $OPTHOME/onbld/env/$1 ]; then
803		. $OPTHOME/onbld/env/$1
804	else
805		echo "Cannot find env file as either $1 or $OPTHOME/onbld/env/$1"
806		exit 1
807	fi
808fi
809
810# contents of stdenv.sh inserted after next line:
811# STDENV_START
812# STDENV_END
813
814# Check if we have sufficient data to continue...
815[[ -v CODEMGR_WS ]] || fatal_error "Error: Variable CODEMGR_WS not set."
816if  [[ "${NIGHTLY_OPTIONS}" == ~(F)n ]] ; then
817	# Check if the gate data are valid if we don't do a "bringover" below
818	[[ -d "${CODEMGR_WS}" ]] || \
819		fatal_error "Error: ${CODEMGR_WS} is not a directory."
820	[[ -f "${CODEMGR_WS}/usr/src/Makefile" ]] || \
821		fatal_error "Error: ${CODEMGR_WS}/usr/src/Makefile not found."
822fi
823
824#
825# place ourselves in a new task, respecting BUILD_PROJECT if set.
826#
827if [ -z "$BUILD_PROJECT" ]; then
828	/usr/bin/newtask -c $$
829else
830	/usr/bin/newtask -c $$ -p $BUILD_PROJECT
831fi
832
833ps -o taskid= -p $$ | read build_taskid
834ps -o project= -p $$ | read build_project
835
836#
837# See if NIGHTLY_OPTIONS is set
838#
839if [ "$NIGHTLY_OPTIONS" = "" ]; then
840	NIGHTLY_OPTIONS="-aBm"
841fi
842
843#
844# If BRINGOVER_WS was not specified, let it default to CLONE_WS
845#
846if [ "$BRINGOVER_WS" = "" ]; then
847	BRINGOVER_WS=$CLONE_WS
848fi
849
850#
851# If BRINGOVER_FILES was not specified, default to usr
852#
853if [ "$BRINGOVER_FILES" = "" ]; then
854	BRINGOVER_FILES="usr"
855fi
856
857check_closed_bins
858
859#
860# Note: changes to the option letters here should also be applied to the
861#	bldenv script.  `d' is listed for backward compatibility.
862#
863NIGHTLY_OPTIONS=-${NIGHTLY_OPTIONS#-}
864OPTIND=1
865while getopts +ABCDdFfGIilMmNnpRrtUuwW FLAG $NIGHTLY_OPTIONS
866do
867	case $FLAG in
868	  A )	A_FLAG=y
869		;;
870	  B )	D_FLAG=y
871		;; # old version of D
872	  C )	C_FLAG=y
873		;;
874	  D )	D_FLAG=y
875		;;
876	  F )	F_FLAG=y
877		;;
878	  f )	f_FLAG=y
879		;;
880	  G )   u_FLAG=y
881		;;
882	  I )	m_FLAG=y
883		p_FLAG=y
884		u_FLAG=y
885		;;
886	  i )	i_FLAG=y
887		;;
888	  l )	l_FLAG=y
889		;;
890	  M )	M_FLAG=y
891		;;
892	  m )	m_FLAG=y
893		;;
894	  N )	N_FLAG=y
895		;;
896	  n )	n_FLAG=y
897		;;
898	  p )	p_FLAG=y
899		;;
900	  R )	m_FLAG=y
901		p_FLAG=y
902		;;
903	  r )	r_FLAG=y
904		;;
905	 +t )	t_FLAG=n
906		;;
907	  U )   if [ -z "${PARENT_ROOT}" ]; then
908			echo "PARENT_ROOT must be set if the U flag is" \
909			    "present in NIGHTLY_OPTIONS."
910			exit 1
911		fi
912		NIGHTLY_PARENT_ROOT=$PARENT_ROOT
913		if [ -n "${PARENT_TOOLS_ROOT}" ]; then
914			NIGHTLY_PARENT_TOOLS_ROOT=$PARENT_TOOLS_ROOT
915		fi
916		U_FLAG=y
917		;;
918	  u )	u_FLAG=y
919		;;
920	  w )	w_FLAG=y
921		;;
922	  W )   W_FLAG=y
923		;;
924	 \? )	echo "$USAGE"
925		exit 1
926		;;
927	esac
928done
929
930if [ $ISUSER -ne 0 ]; then
931	# Set default value for STAFFER, if needed.
932	if [ -z "$STAFFER" -o "$STAFFER" = "nobody" ]; then
933		STAFFER=`/usr/xpg4/bin/id -un`
934		export STAFFER
935	fi
936fi
937
938if [ -z "$MAILTO" -o "$MAILTO" = "nobody" ]; then
939	MAILTO=$STAFFER
940	export MAILTO
941fi
942
943PATH="$OPTHOME/onbld/bin:$OPTHOME/onbld/bin/${MACH}:/usr/ccs/bin"
944PATH="$PATH:$OPTHOME/SUNWspro/bin:/usr/bin:/usr/sbin:/usr/ucb"
945PATH="$PATH:/usr/openwin/bin:/usr/sfw/bin:/opt/sfw/bin:."
946export PATH
947
948# roots of source trees, both relative to $SRC and absolute.
949relsrcdirs="."
950abssrcdirs="$SRC"
951
952PROTOCMPTERSE="protocmp.terse -gu"
953POUND_SIGN="#"
954# have we set RELEASE_DATE in our env file?
955if [ -z "$RELEASE_DATE" ]; then
956	RELEASE_DATE=$(LC_ALL=C date +"%B %Y")
957fi
958BUILD_DATE=$(LC_ALL=C date +%Y-%b-%d)
959BASEWSDIR=$(basename $CODEMGR_WS)
960DEV_CM="\"@(#)SunOS Internal Development: $LOGNAME $BUILD_DATE [$BASEWSDIR]\""
961
962# we export POUND_SIGN, RELEASE_DATE and DEV_CM to speed up the build process
963# by avoiding repeated shell invocations to evaluate Makefile.master
964# definitions.
965export POUND_SIGN RELEASE_DATE DEV_CM
966
967maketype="distributed"
968if [[ -z "$MAKE" ]]; then
969	MAKE=dmake
970elif [[ ! -x "$MAKE" ]]; then
971	echo "\$MAKE is set to garbage in the environment"
972	exit 1
973fi
974# get the dmake version string alone
975DMAKE_VERSION=$( $MAKE -v )
976DMAKE_VERSION=${DMAKE_VERSION#*: }
977# focus in on just the dotted version number alone
978DMAKE_MAJOR=$( echo $DMAKE_VERSION | \
979	sed -e 's/.*\<\([^.]*\.[^   ]*\).*$/\1/' )
980# extract the second (or final) integer
981DMAKE_MINOR=${DMAKE_MAJOR#*.}
982DMAKE_MINOR=${DMAKE_MINOR%%.*}
983# extract the first integer
984DMAKE_MAJOR=${DMAKE_MAJOR%%.*}
985CHECK_DMAKE=${CHECK_DMAKE:-y}
986# x86 was built on the 12th, sparc on the 13th.
987if [ "$CHECK_DMAKE" = "y" -a \
988     "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/12" -a \
989     "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/13" -a \( \
990     "$DMAKE_MAJOR" -lt 7 -o \
991     "$DMAKE_MAJOR" -eq 7 -a "$DMAKE_MINOR" -lt 4 \) ]; then
992	if [ -z "$DMAKE_VERSION" ]; then
993		echo "$MAKE is missing."
994		exit 1
995	fi
996	echo `whence $MAKE`" version is:"
997	echo "  ${DMAKE_VERSION}"
998	cat <<EOF
999
1000This version may not be safe for use, if you really want to use this version
1001anyway add the following to your environment to disable this check:
1002
1003  CHECK_DMAKE=n
1004EOF
1005	exit 1
1006fi
1007export PATH
1008export MAKE
1009
1010if [ "${SUNWSPRO}" != "" ]; then
1011	PATH="${SUNWSPRO}/bin:$PATH"
1012	export PATH
1013fi
1014
1015hostname=$(uname -n)
1016if [[ $DMAKE_MAX_JOBS != +([0-9]) || $DMAKE_MAX_JOBS -eq 0 ]]
1017then
1018	maxjobs=
1019	if [[ -f $HOME/.make.machines ]]
1020	then
1021		# Note: there is a hard tab and space character in the []s
1022		# below.
1023		egrep -i "^[ 	]*$hostname[ 	\.]" \
1024			$HOME/.make.machines | read host jobs
1025		maxjobs=${jobs##*=}
1026	fi
1027
1028	if [[ $maxjobs != +([0-9]) || $maxjobs -eq 0 ]]
1029	then
1030		# default
1031		maxjobs=4
1032	fi
1033
1034	export DMAKE_MAX_JOBS=$maxjobs
1035fi
1036
1037DMAKE_MODE=parallel;
1038export DMAKE_MODE
1039
1040if [ -z "${ROOT}" ]; then
1041	echo "ROOT must be set."
1042	exit 1
1043fi
1044
1045#
1046# if -V flag was given, reset VERSION to V_ARG
1047#
1048if [ "$V_FLAG" = "y" ]; then
1049	VERSION=$V_ARG
1050fi
1051
1052TMPDIR="/tmp/nightly.tmpdir.$$"
1053export TMPDIR
1054rm -rf ${TMPDIR}
1055mkdir -p $TMPDIR || exit 1
1056chmod 777 $TMPDIR
1057
1058#
1059# Keep elfsign's use of pkcs11_softtoken from looking in the user home
1060# directory, which doesn't always work.   Needed until all build machines
1061# have the fix for 6271754
1062#
1063SOFTTOKEN_DIR=$TMPDIR
1064export SOFTTOKEN_DIR
1065
1066#
1067# Tools should only be built non-DEBUG.  Keep track of the tools proto
1068# area path relative to $TOOLS, because the latter changes in an
1069# export build.
1070#
1071# TOOLS_PROTO is included below for builds other than usr/src/tools
1072# that look for this location.  For usr/src/tools, this will be
1073# overridden on the $MAKE command line in build_tools().
1074#
1075TOOLS=${SRC}/tools
1076TOOLS_PROTO_REL=proto/root_${MACH}-nd
1077TOOLS_PROTO=${TOOLS}/${TOOLS_PROTO_REL};	export TOOLS_PROTO
1078
1079unset   CFLAGS LD_LIBRARY_PATH LDFLAGS
1080
1081# create directories that are automatically removed if the nightly script
1082# fails to start correctly
1083function newdir {
1084	dir=$1
1085	toadd=
1086	while [ ! -d $dir ]; do
1087		toadd="$dir $toadd"
1088		dir=`dirname $dir`
1089	done
1090	torm=
1091	newlist=
1092	for dir in $toadd; do
1093		if staffer mkdir $dir; then
1094			newlist="$ISUSER $dir $newlist"
1095			torm="$dir $torm"
1096		else
1097			[ -z "$torm" ] || staffer rmdir $torm
1098			return 1
1099		fi
1100	done
1101	newdirlist="$newlist $newdirlist"
1102	return 0
1103}
1104newdirlist=
1105
1106[ -d $CODEMGR_WS ] || newdir $CODEMGR_WS || exit 1
1107
1108# since this script assumes the build is from full source, it nullifies
1109# variables likely to have been set by a "ws" script; nullification
1110# confines the search space for headers and libraries to the proto area
1111# built from this immediate source.
1112ENVLDLIBS1=
1113ENVLDLIBS2=
1114ENVLDLIBS3=
1115ENVCPPFLAGS1=
1116ENVCPPFLAGS2=
1117ENVCPPFLAGS3=
1118ENVCPPFLAGS4=
1119PARENT_ROOT=
1120
1121export ENVLDLIBS3 ENVCPPFLAGS1 ENVCPPFLAGS2 ENVCPPFLAGS3 ENVCPPFLAGS4 \
1122	ENVLDLIBS1 ENVLDLIBS2 PARENT_ROOT
1123
1124PKGARCHIVE_ORIG=$PKGARCHIVE
1125
1126#
1127# Juggle the logs and optionally send mail on completion.
1128#
1129
1130function logshuffle {
1131    	LLOG="$ATLOG/log.`date '+%F.%H:%M'`"
1132	if [ -f $LLOG -o -d $LLOG ]; then
1133	    	LLOG=$LLOG.$$
1134	fi
1135	mkdir $LLOG
1136	export LLOG
1137
1138	if [ "$build_ok" = "y" ]; then
1139		mv $ATLOG/proto_list_${MACH} $LLOG
1140
1141		if [ -f $ATLOG/proto_list_tools_${MACH} ]; then
1142			mv $ATLOG/proto_list_tools_${MACH} $LLOG
1143	        fi
1144
1145		if [ -f $TMPDIR/wsdiff.results ]; then
1146		    	mv $TMPDIR/wsdiff.results $LLOG
1147		fi
1148
1149		if [ -f $TMPDIR/wsdiff-nd.results ]; then
1150			mv $TMPDIR/wsdiff-nd.results $LLOG
1151		fi
1152	fi
1153
1154	#
1155	# Now that we're about to send mail, it's time to check the noise
1156	# file.  In the event that an error occurs beyond this point, it will
1157	# be recorded in the nightly.log file, but nowhere else.  This would
1158	# include only errors that cause the copying of the noise log to fail
1159	# or the mail itself not to be sent.
1160	#
1161
1162	exec >>$LOGFILE 2>&1
1163	if [ -s $build_noise_file ]; then
1164	    	echo "\n==== Nightly build noise ====\n" |
1165		    tee -a $LOGFILE >>$mail_msg_file
1166		cat $build_noise_file >>$LOGFILE
1167		cat $build_noise_file >>$mail_msg_file
1168		echo | tee -a $LOGFILE >>$mail_msg_file
1169	fi
1170	rm -f $build_noise_file
1171
1172	case "$build_ok" in
1173		y)
1174			state=Completed
1175			;;
1176		i)
1177			state=Interrupted
1178			;;
1179		*)
1180	    		state=Failed
1181			;;
1182	esac
1183
1184	if [[ $state != "Interrupted" && $build_extras_ok != "y" ]]; then
1185		state=Failed
1186	fi
1187
1188	NIGHTLY_STATUS=$state
1189	export NIGHTLY_STATUS
1190
1191	run_hook POST_NIGHTLY $state
1192	run_hook SYS_POST_NIGHTLY $state
1193
1194	#
1195	# mailx(1) sets From: based on the -r flag
1196	# if it is given.
1197	#
1198	mailx_r=
1199	if [[ -n "${MAILFROM}" ]]; then
1200		mailx_r="-r ${MAILFROM}"
1201	fi
1202
1203	cat $build_time_file $build_environ_file $mail_msg_file \
1204	    > ${LLOG}/mail_msg
1205	if [ "$m_FLAG" = "y" ]; then
1206	    	cat ${LLOG}/mail_msg | /usr/bin/mailx ${mailx_r} -s \
1207	"Nightly ${MACH} Build of `basename ${CODEMGR_WS}` ${state}." \
1208			${MAILTO}
1209	fi
1210
1211	if [ "$u_FLAG" = "y" -a "$build_ok" = "y" ]; then
1212	    	staffer cp ${LLOG}/mail_msg $PARENT_WS/usr/src/mail_msg-${MACH}
1213		staffer cp $LOGFILE $PARENT_WS/usr/src/nightly-${MACH}.log
1214	fi
1215
1216	mv $LOGFILE $LLOG
1217}
1218
1219#
1220#	Remove the locks and temporary files on any exit
1221#
1222function cleanup {
1223    	logshuffle
1224
1225	[ -z "$lockfile" ] || staffer rm -f $lockfile
1226	[ -z "$atloglockfile" ] || rm -f $atloglockfile
1227	[ -z "$ulockfile" ] || staffer rm -f $ulockfile
1228	[ -z "$Ulockfile" ] || rm -f $Ulockfile
1229
1230	set -- $newdirlist
1231	while [ $# -gt 0 ]; do
1232		ISUSER=$1 staffer rmdir $2
1233		shift; shift
1234	done
1235	rm -rf $TMPDIR
1236}
1237
1238function cleanup_signal {
1239    	build_ok=i
1240	# this will trigger cleanup(), above.
1241	exit 1
1242}
1243
1244trap cleanup 0
1245trap cleanup_signal 1 2 3 15
1246
1247#
1248# Generic lock file processing -- make sure that the lock file doesn't
1249# exist.  If it does, it should name the build host and PID.  If it
1250# doesn't, then make sure we can create it.  Clean up locks that are
1251# known to be stale (assumes host name is unique among build systems
1252# for the workspace).
1253#
1254function create_lock {
1255	lockf=$1
1256	lockvar=$2
1257
1258	ldir=`dirname $lockf`
1259	[ -d $ldir ] || newdir $ldir || exit 1
1260	eval $lockvar=$lockf
1261
1262	while ! staffer ln -s $hostname.$STAFFER.$$ $lockf 2> /dev/null; do
1263		basews=`basename $CODEMGR_WS`
1264		ls -l $lockf | nawk '{print $NF}' | IFS=. read host user pid
1265		if [ "$host" != "$hostname" ]; then
1266			echo "$MACH build of $basews apparently" \
1267			    "already started by $user on $host as $pid."
1268			exit 1
1269		elif kill -s 0 $pid 2>/dev/null; then
1270			echo "$MACH build of $basews already started" \
1271			    "by $user as $pid."
1272			exit 1
1273		else
1274			# stale lock; clear it out and try again
1275			rm -f $lockf
1276		fi
1277	done
1278}
1279
1280#
1281# Return the list of interesting proto areas, depending on the current
1282# options.
1283#
1284function allprotos {
1285	typeset roots="$ROOT"
1286
1287	if [[ "$F_FLAG" = n && "$MULTI_PROTO" = yes ]]; then
1288		roots="$roots $ROOT-nd"
1289	fi
1290
1291	echo $roots
1292}
1293
1294# Ensure no other instance of this script is running on this host.
1295# LOCKNAME can be set in <env_file>, and is by default, but is not
1296# required due to the use of $ATLOG below.
1297if [ -n "$LOCKNAME" ]; then
1298	create_lock /tmp/$LOCKNAME "lockfile"
1299fi
1300#
1301# Create from one, two, or three other locks:
1302#	$ATLOG/nightly.lock
1303#		- protects against multiple builds in same workspace
1304#	$PARENT_WS/usr/src/nightly.$MACH.lock
1305#		- protects against multiple 'u' copy-backs
1306#	$NIGHTLY_PARENT_ROOT/nightly.lock
1307#		- protects against multiple 'U' copy-backs
1308#
1309# Overriding ISUSER to 1 causes the lock to be created as root if the
1310# script is run as root.  The default is to create it as $STAFFER.
1311ISUSER=1 create_lock $ATLOG/nightly.lock "atloglockfile"
1312if [ "$u_FLAG" = "y" ]; then
1313	create_lock $PARENT_WS/usr/src/nightly.$MACH.lock "ulockfile"
1314fi
1315if [ "$U_FLAG" = "y" ]; then
1316	# NIGHTLY_PARENT_ROOT is written as root if script invoked as root.
1317	ISUSER=1 create_lock $NIGHTLY_PARENT_ROOT/nightly.lock "Ulockfile"
1318fi
1319
1320# Locks have been taken, so we're doing a build and we're committed to
1321# the directories we may have created so far.
1322newdirlist=
1323
1324#
1325# Create mail_msg_file
1326#
1327mail_msg_file="${TMPDIR}/mail_msg"
1328touch $mail_msg_file
1329build_time_file="${TMPDIR}/build_time"
1330build_environ_file="${TMPDIR}/build_environ"
1331touch $build_environ_file
1332#
1333#	Move old LOGFILE aside
1334#	ATLOG directory already made by 'create_lock' above
1335#
1336if [ -f $LOGFILE ]; then
1337	mv -f $LOGFILE ${LOGFILE}-
1338fi
1339#
1340#	Build OsNet source
1341#
1342START_DATE=`date`
1343SECONDS=0
1344echo "\n==== Nightly $maketype build started:   $START_DATE ====" \
1345    | tee -a $LOGFILE > $build_time_file
1346
1347echo "\nBuild project:  $build_project\nBuild taskid:   $build_taskid" | \
1348    tee -a $mail_msg_file >> $LOGFILE
1349
1350# make sure we log only to the nightly build file
1351build_noise_file="${TMPDIR}/build_noise"
1352exec </dev/null >$build_noise_file 2>&1
1353
1354run_hook SYS_PRE_NIGHTLY
1355run_hook PRE_NIGHTLY
1356
1357echo "\n==== list of environment variables ====\n" >> $LOGFILE
1358env >> $LOGFILE
1359
1360echo "\n==== Nightly argument issues ====\n" | tee -a $mail_msg_file >> $LOGFILE
1361
1362if [ "$N_FLAG" = "y" ]; then
1363	if [ "$p_FLAG" = "y" ]; then
1364		cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1365WARNING: the p option (create packages) is set, but so is the N option (do
1366         not run protocmp); this is dangerous; you should unset the N option
1367EOF
1368	else
1369		cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1370Warning: the N option (do not run protocmp) is set; it probably shouldn't be
1371EOF
1372	fi
1373	echo "" | tee -a $mail_msg_file >> $LOGFILE
1374fi
1375
1376if [ "$D_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
1377	#
1378	# In the past we just complained but went ahead with the lint
1379	# pass, even though the proto area was built non-DEBUG.  It's
1380	# unlikely that non-DEBUG headers will make a difference, but
1381	# rather than assuming it's a safe combination, force the user
1382	# to specify a DEBUG build.
1383	#
1384	echo "WARNING: DEBUG build not requested; disabling lint.\n" \
1385	    | tee -a $mail_msg_file >> $LOGFILE
1386	l_FLAG=n
1387fi
1388
1389if [ "$f_FLAG" = "y" ]; then
1390	if [ "$i_FLAG" = "y" ]; then
1391		echo "WARNING: the -f flag cannot be used during incremental" \
1392		    "builds; ignoring -f\n" | tee -a $mail_msg_file >> $LOGFILE
1393		f_FLAG=n
1394	fi
1395	if [ "${l_FLAG}${p_FLAG}" != "yy" ]; then
1396		echo "WARNING: the -f flag requires -l, and -p;" \
1397		    "ignoring -f\n" | tee -a $mail_msg_file >> $LOGFILE
1398		f_FLAG=n
1399	fi
1400fi
1401
1402if [ "$w_FLAG" = "y" -a ! -d $ROOT ]; then
1403	echo "WARNING: -w specified, but $ROOT does not exist;" \
1404	    "ignoring -w\n" | tee -a $mail_msg_file >> $LOGFILE
1405	w_FLAG=n
1406fi
1407
1408if [ "$t_FLAG" = "n" ]; then
1409	#
1410	# We're not doing a tools build, so make sure elfsign(1) is
1411	# new enough to safely sign non-crypto binaries.  We test
1412	# debugging output from elfsign to detect the old version.
1413	#
1414	newelfsigntest=`SUNW_CRYPTO_DEBUG=stderr /usr/bin/elfsign verify \
1415	    -e /usr/lib/security/pkcs11_softtoken.so.1 2>&1 \
1416	    | egrep algorithmOID`
1417	if [ -z "$newelfsigntest" ]; then
1418		echo "WARNING: /usr/bin/elfsign out of date;" \
1419		    "will only sign crypto modules\n" | \
1420		    tee -a $mail_msg_file >> $LOGFILE
1421		export ELFSIGN_OBJECT=true
1422	elif [ "$VERIFY_ELFSIGN" = "y" ]; then
1423		echo "WARNING: VERIFY_ELFSIGN=y requires" \
1424		    "the -t flag; ignoring VERIFY_ELFSIGN\n" | \
1425		    tee -a $mail_msg_file >> $LOGFILE
1426	fi
1427fi
1428
1429case $MULTI_PROTO in
1430yes|no)	;;
1431*)
1432	echo "WARNING: MULTI_PROTO is \"$MULTI_PROTO\"; " \
1433	    "should be \"yes\" or \"no\"." | tee -a $mail_msg_file >> $LOGFILE
1434	echo "Setting MULTI_PROTO to \"no\".\n" | \
1435	    tee -a $mail_msg_file >> $LOGFILE
1436	export MULTI_PROTO=no
1437	;;
1438esac
1439
1440echo "\n==== Build version ====\n" | tee -a $mail_msg_file >> $LOGFILE
1441echo $VERSION | tee -a $mail_msg_file >> $LOGFILE
1442
1443# Save the current proto area if we're comparing against the last build
1444if [ "$w_FLAG" = "y" -a -d "$ROOT" ]; then
1445    if [ -d "$ROOT.prev" ]; then
1446	rm -rf $ROOT.prev
1447    fi
1448    mv $ROOT $ROOT.prev
1449fi
1450
1451# Same for non-DEBUG proto area
1452if [ "$w_FLAG" = "y" -a "$MULTI_PROTO" = yes -a -d "$ROOT-nd" ]; then
1453	if [ -d "$ROOT-nd.prev" ]; then
1454		rm -rf $ROOT-nd.prev
1455	fi
1456	mv $ROOT-nd $ROOT-nd.prev
1457fi
1458
1459#
1460# Echo the SCM type of the parent workspace, this can't just be which_scm
1461# as that does not know how to identify various network repositories.
1462#
1463function parent_wstype {
1464	typeset scm_type junk
1465
1466	CODEMGR_WS="$BRINGOVER_WS" "$WHICH_SCM" 2>/dev/null \
1467	    | read scm_type junk
1468	if [[ -z "$scm_type" || "$scm_type" == unknown ]]; then
1469		# Probe BRINGOVER_WS to determine its type
1470		if [[ $BRINGOVER_WS == ssh://* ]]; then
1471			scm_type="mercurial"
1472		elif [[ $BRINGOVER_WS == http://* ]] && \
1473		    wget -q -O- --save-headers "$BRINGOVER_WS/?cmd=heads" | \
1474		    egrep -s "application/mercurial" 2> /dev/null; then
1475			scm_type="mercurial"
1476		else
1477			scm_type="none"
1478		fi
1479	fi
1480
1481	# fold both unsupported and unrecognized results into "none"
1482	case "$scm_type" in
1483	mercurial)
1484		;;
1485	*)	scm_type=none
1486		;;
1487	esac
1488
1489	echo $scm_type
1490}
1491
1492# Echo the SCM types of $CODEMGR_WS and $BRINGOVER_WS
1493function child_wstype {
1494	typeset scm_type junk
1495
1496	# Probe CODEMGR_WS to determine its type
1497	if [[ -d $CODEMGR_WS ]]; then
1498		$WHICH_SCM | read scm_type junk || exit 1
1499	fi
1500
1501	case "$scm_type" in
1502	none|git|mercurial)
1503		;;
1504	*)	scm_type=none
1505		;;
1506	esac
1507
1508	echo $scm_type
1509}
1510
1511SCM_TYPE=$(child_wstype)
1512
1513#
1514#	Decide whether to clobber
1515#
1516if [ "$i_FLAG" = "n" -a -d "$SRC" ]; then
1517	echo "\n==== Make clobber at `date` ====\n" >> $LOGFILE
1518
1519	cd $SRC
1520	# remove old clobber file
1521	rm -f $SRC/clobber.out
1522	rm -f $SRC/clobber-${MACH}.out
1523
1524	# Remove all .make.state* files, just in case we are restarting
1525	# the build after having interrupted a previous 'make clobber'.
1526	find . \( -name SCCS -o -name .hg -o -name .svn -o -name .git \
1527		-o -name 'interfaces.*' \) -prune \
1528		-o -name '.make.*' -print | xargs rm -f
1529
1530	$MAKE -ek clobber 2>&1 | tee -a $SRC/clobber-${MACH}.out >> $LOGFILE
1531	echo "\n==== Make clobber ERRORS ====\n" >> $mail_msg_file
1532	grep "$MAKE:" $SRC/clobber-${MACH}.out |
1533		egrep -v "Ignoring unknown host" | \
1534		tee $TMPDIR/clobber_errs >> $mail_msg_file
1535
1536	if [[ -s $TMPDIR/clobber_errs ]]; then
1537		build_extras_ok=n
1538	fi
1539
1540	if [[ "$t_FLAG" = "y" ]]; then
1541		echo "\n==== Make tools clobber at `date` ====\n" >> $LOGFILE
1542		cd ${TOOLS}
1543		rm -f ${TOOLS}/clobber-${MACH}.out
1544		$MAKE TOOLS_PROTO=$TOOLS_PROTO -ek clobber 2>&1 | \
1545			tee -a ${TOOLS}/clobber-${MACH}.out >> $LOGFILE
1546		echo "\n==== Make tools clobber ERRORS ====\n" \
1547			>> $mail_msg_file
1548		grep "$MAKE:" ${TOOLS}/clobber-${MACH}.out \
1549			>> $mail_msg_file
1550		if (( $? == 0 )); then
1551			build_extras_ok=n
1552		fi
1553		rm -rf ${TOOLS_PROTO}
1554		mkdir -p ${TOOLS_PROTO}
1555	fi
1556
1557	typeset roots=$(allprotos)
1558	echo "\n\nClearing $roots" >> "$LOGFILE"
1559	rm -rf $roots
1560
1561	# Get back to a clean workspace as much as possible to catch
1562	# problems that only occur on fresh workspaces.
1563	# Remove all .make.state* files, libraries, and .o's that may
1564	# have been omitted from clobber.  A couple of libraries are
1565	# under source code control, so leave them alone.
1566	# We should probably blow away temporary directories too.
1567	cd $SRC
1568	find $relsrcdirs \( -name SCCS -o -name .hg -o -name .svn \
1569	    -o -name .git -o -name 'interfaces.*' \) -prune -o \
1570	    \( -name '.make.*' -o -name 'lib*.a' -o -name 'lib*.so*' -o \
1571	       -name '*.o' \) -print | \
1572	    grep -v 'tools/ctf/dwarf/.*/libdwarf' | xargs rm -f
1573else
1574	echo "\n==== No clobber at `date` ====\n" >> $LOGFILE
1575fi
1576
1577type bringover_mercurial > /dev/null 2>&1 || function bringover_mercurial {
1578	typeset -x PATH=$PATH
1579
1580	# If the repository doesn't exist yet, then we want to populate it.
1581	if [[ ! -d $CODEMGR_WS/.hg ]]; then
1582		staffer hg init $CODEMGR_WS
1583		staffer echo "[paths]" > $CODEMGR_WS/.hg/hgrc
1584		staffer echo "default=$BRINGOVER_WS" >> $CODEMGR_WS/.hg/hgrc
1585		touch $TMPDIR/new_repository
1586	fi
1587
1588	typeset -x HGMERGE="/bin/false"
1589
1590	#
1591	# If the user has changes, regardless of whether those changes are
1592	# committed, and regardless of whether those changes conflict, then
1593	# we'll attempt to merge them either implicitly (uncommitted) or
1594	# explicitly (committed).
1595	#
1596	# These are the messages we'll use to help clarify mercurial output
1597	# in those cases.
1598	#
1599	typeset mergefailmsg="\
1600***\n\
1601*** nightly was unable to automatically merge your changes.  You should\n\
1602*** redo the full merge manually, following the steps outlined by mercurial\n\
1603*** above, then restart nightly.\n\
1604***\n"
1605	typeset mergepassmsg="\
1606***\n\
1607*** nightly successfully merged your changes.  This means that your working\n\
1608*** directory has been updated, but those changes are not yet committed.\n\
1609*** After nightly completes, you should validate the results of the merge,\n\
1610*** then use hg commit manually.\n\
1611***\n"
1612
1613	#
1614	# For each repository in turn:
1615	#
1616	# 1. Do the pull.  If this fails, dump the output and bail out.
1617	#
1618	# 2. If the pull resulted in an extra head, do an explicit merge.
1619	#    If this fails, dump the output and bail out.
1620	#
1621	# Because we can't rely on Mercurial to exit with a failure code
1622	# when a merge fails (Mercurial issue #186), we must grep the
1623	# output of pull/merge to check for attempted and/or failed merges.
1624	#
1625	# 3. If a merge failed, set the message and fail the bringover.
1626	#
1627	# 4. Otherwise, if a merge succeeded, set the message
1628	#
1629	# 5. Dump the output, and any message from step 3 or 4.
1630	#
1631
1632	typeset HG_SOURCE=$BRINGOVER_WS
1633	if [ ! -f $TMPDIR/new_repository ]; then
1634		HG_SOURCE=$TMPDIR/open_bundle.hg
1635		staffer hg --cwd $CODEMGR_WS incoming --bundle $HG_SOURCE \
1636		    -v $BRINGOVER_WS > $TMPDIR/incoming_open.out
1637
1638		#
1639		# If there are no incoming changesets, then incoming will
1640		# fail, and there will be no bundle file.  Reset the source,
1641		# to allow the remaining logic to complete with no false
1642		# negatives.  (Unlike incoming, pull will return success
1643		# for the no-change case.)
1644		#
1645		if (( $? != 0 )); then
1646			HG_SOURCE=$BRINGOVER_WS
1647		fi
1648	fi
1649
1650	staffer hg --cwd $CODEMGR_WS pull -u $HG_SOURCE \
1651	    > $TMPDIR/pull_open.out 2>&1
1652	if (( $? != 0 )); then
1653		printf "%s: pull failed as follows:\n\n" "$CODEMGR_WS"
1654		cat $TMPDIR/pull_open.out
1655		if grep "^merging.*failed" $TMPDIR/pull_open.out > /dev/null 2>&1; then
1656			printf "$mergefailmsg"
1657		fi
1658		touch $TMPDIR/bringover_failed
1659		return
1660	fi
1661
1662	if grep "not updating" $TMPDIR/pull_open.out > /dev/null 2>&1; then
1663		staffer hg --cwd $CODEMGR_WS merge \
1664		    >> $TMPDIR/pull_open.out 2>&1
1665		if (( $? != 0 )); then
1666			printf "%s: merge failed as follows:\n\n" \
1667			    "$CODEMGR_WS"
1668			cat $TMPDIR/pull_open.out
1669			if grep "^merging.*failed" $TMPDIR/pull_open.out \
1670			    > /dev/null 2>&1; then
1671				printf "$mergefailmsg"
1672			fi
1673			touch $TMPDIR/bringover_failed
1674			return
1675		fi
1676	fi
1677
1678	printf "updated %s with the following results:\n" "$CODEMGR_WS"
1679	cat $TMPDIR/pull_open.out
1680	if grep "^merging" $TMPDIR/pull_open.out >/dev/null 2>&1; then
1681		printf "$mergepassmsg"
1682	fi
1683	printf "\n"
1684
1685	#
1686	# Per-changeset output is neither useful nor manageable for a
1687	# newly-created repository.
1688	#
1689	if [ -f $TMPDIR/new_repository ]; then
1690		return
1691	fi
1692
1693	printf "\nadded the following changesets to open repository:\n"
1694	cat $TMPDIR/incoming_open.out
1695}
1696
1697type bringover_none > /dev/null 2>&1 || function bringover_none {
1698	echo "Couldn't figure out what kind of SCM to use for $BRINGOVER_WS."
1699	touch $TMPDIR/bringover_failed
1700}
1701
1702#
1703#	Decide whether to bringover to the codemgr workspace
1704#
1705if [ "$n_FLAG" = "n" ]; then
1706	PARENT_SCM_TYPE=$(parent_wstype)
1707
1708	if [[ $SCM_TYPE != none && $SCM_TYPE != $PARENT_SCM_TYPE ]]; then
1709		echo "cannot bringover from $PARENT_SCM_TYPE to $SCM_TYPE, " \
1710		    "quitting at `date`." | tee -a $mail_msg_file >> $LOGFILE
1711		exit 1
1712	fi
1713
1714	run_hook PRE_BRINGOVER
1715
1716	echo "\n==== bringover to $CODEMGR_WS at `date` ====\n" >> $LOGFILE
1717	echo "\n==== BRINGOVER LOG ====\n" >> $mail_msg_file
1718
1719	eval "bringover_${PARENT_SCM_TYPE}" 2>&1 |
1720		tee -a $mail_msg_file >> $LOGFILE
1721
1722	if [ -f $TMPDIR/bringover_failed ]; then
1723		rm -f $TMPDIR/bringover_failed
1724		build_ok=n
1725		echo "trouble with bringover, quitting at `date`." |
1726			tee -a $mail_msg_file >> $LOGFILE
1727		exit 1
1728	fi
1729
1730	#
1731	# It's possible that we used the bringover above to create
1732	# $CODEMGR_WS.  If so, then SCM_TYPE was previously "none,"
1733	# but should now be the same as $BRINGOVER_WS.
1734	#
1735	[[ $SCM_TYPE = none ]] && SCM_TYPE=$PARENT_SCM_TYPE
1736
1737	run_hook POST_BRINGOVER
1738
1739	check_closed_bins
1740
1741else
1742	echo "\n==== No bringover to $CODEMGR_WS ====\n" >> $LOGFILE
1743fi
1744
1745# Safeguards
1746[[ -v CODEMGR_WS ]] || fatal_error "Error: Variable CODEMGR_WS not set."
1747[[ -d "${CODEMGR_WS}" ]] || fatal_error "Error: ${CODEMGR_WS} is not a directory."
1748[[ -f "${CODEMGR_WS}/usr/src/Makefile" ]] || fatal_error "Error: ${CODEMGR_WS}/usr/src/Makefile not found."
1749
1750echo "\n==== Build environment ====\n" | tee -a $build_environ_file >> $LOGFILE
1751
1752# System
1753whence uname | tee -a $build_environ_file >> $LOGFILE
1754uname -a 2>&1 | tee -a $build_environ_file >> $LOGFILE
1755echo | tee -a $build_environ_file >> $LOGFILE
1756
1757# make
1758whence $MAKE | tee -a $build_environ_file >> $LOGFILE
1759$MAKE -v | tee -a $build_environ_file >> $LOGFILE
1760echo "number of concurrent jobs = $DMAKE_MAX_JOBS" |
1761    tee -a $build_environ_file >> $LOGFILE
1762
1763#
1764# Report the compiler versions.
1765#
1766
1767if [[ ! -f $SRC/Makefile ]]; then
1768	build_ok=n
1769	echo "\nUnable to find \"Makefile\" in $SRC." | \
1770	    tee -a $build_environ_file >> $LOGFILE
1771	exit 1
1772fi
1773
1774( cd $SRC
1775  for target in cc-version cc64-version java-version; do
1776	echo
1777	#
1778	# Put statefile somewhere we know we can write to rather than trip
1779	# over a read-only $srcroot.
1780	#
1781	rm -f $TMPDIR/make-state
1782	export SRC
1783	if $MAKE -K $TMPDIR/make-state -e $target 2>/dev/null; then
1784		continue
1785	fi
1786	touch $TMPDIR/nocompiler
1787  done
1788  echo
1789) | tee -a $build_environ_file >> $LOGFILE
1790
1791if [ -f $TMPDIR/nocompiler ]; then
1792	rm -f $TMPDIR/nocompiler
1793	build_ok=n
1794	echo "Aborting due to missing compiler." |
1795		tee -a $build_environ_file >> $LOGFILE
1796	exit 1
1797fi
1798
1799# as
1800whence as | tee -a $build_environ_file >> $LOGFILE
1801as -V 2>&1 | head -1 | tee -a $build_environ_file >> $LOGFILE
1802echo | tee -a $build_environ_file >> $LOGFILE
1803
1804# Check that we're running a capable link-editor
1805whence ld | tee -a $build_environ_file >> $LOGFILE
1806LDVER=`ld -V 2>&1`
1807echo $LDVER | tee -a $build_environ_file >> $LOGFILE
1808LDVER=`echo $LDVER | sed -e "s/.*-1\.\([0-9]*\).*/\1/"`
1809if [ `expr $LDVER \< 422` -eq 1 ]; then
1810	echo "The link-editor needs to be at version 422 or higher to build" | \
1811	    tee -a $build_environ_file >> $LOGFILE
1812	echo "the latest stuff.  Hope your build works." | \
1813	    tee -a $build_environ_file >> $LOGFILE
1814fi
1815
1816#
1817# Build and use the workspace's tools if requested
1818#
1819if [[ "$t_FLAG" = "y" ]]; then
1820	set_non_debug_build_flags
1821
1822	build_tools ${TOOLS_PROTO}
1823	if (( $? != 0 )); then
1824		build_ok=n
1825	else
1826		use_tools $TOOLS_PROTO
1827	fi
1828fi
1829
1830# timestamp the start of the normal build; the findunref tool uses it.
1831touch $SRC/.build.tstamp
1832
1833normal_build
1834
1835ORIG_SRC=$SRC
1836BINARCHIVE=${CODEMGR_WS}/bin-${MACH}.cpio.Z
1837
1838#
1839# There are several checks that need to look at the proto area, but
1840# they only need to look at one, and they don't care whether it's
1841# DEBUG or non-DEBUG.
1842#
1843if [[ "$MULTI_PROTO" = yes && "$D_FLAG" = n ]]; then
1844	checkroot=$ROOT-nd
1845else
1846	checkroot=$ROOT
1847fi
1848
1849if [ "$build_ok" = "y" ]; then
1850	echo "\n==== Creating protolist system file at `date` ====" \
1851		>> $LOGFILE
1852	protolist $checkroot > $ATLOG/proto_list_${MACH}
1853	echo "==== protolist system file created at `date` ====\n" \
1854		>> $LOGFILE
1855
1856	if [ "$N_FLAG" != "y" ]; then
1857
1858		E1=
1859		f1=
1860		for f in $f1; do
1861			if [ -f "$f" ]; then
1862				E1="$E1 -e $f"
1863			fi
1864		done
1865
1866		E2=
1867		f2=
1868		if [ -d "$SRC/pkg" ]; then
1869			f2="$f2 exceptions/packaging"
1870		fi
1871
1872		for f in $f2; do
1873			if [ -f "$f" ]; then
1874				E2="$E2 -e $f"
1875			fi
1876		done
1877	fi
1878
1879	if [ "$N_FLAG" != "y" -a -d $SRC/pkg ]; then
1880		echo "\n==== Validating manifests against proto area ====\n" \
1881		    >> $mail_msg_file
1882		( cd $SRC/pkg ; $MAKE -e protocmp ROOT="$checkroot" ) | \
1883		    tee $TMPDIR/protocmp_noise >> $mail_msg_file
1884		if [[ -s $TMPDIR/protocmp_noise ]]; then
1885			build_extras_ok=n
1886		fi
1887	fi
1888
1889	if [ "$N_FLAG" != "y" -a -f "$REF_PROTO_LIST" ]; then
1890		echo "\n==== Impact on proto area ====\n" >> $mail_msg_file
1891		if [ -n "$E2" ]; then
1892			ELIST=$E2
1893		else
1894			ELIST=$E1
1895		fi
1896		$PROTOCMPTERSE \
1897			"Files in yesterday's proto area, but not today's:" \
1898			"Files in today's proto area, but not yesterday's:" \
1899			"Files that changed between yesterday and today:" \
1900			${ELIST} \
1901			-d $REF_PROTO_LIST \
1902			$ATLOG/proto_list_${MACH} \
1903			>> $mail_msg_file
1904	fi
1905fi
1906
1907if [[ "$u_FLAG" == "y" && "$build_ok" == "y" && \
1908    "$build_extras_ok" == "y" ]]; then
1909	staffer cp $ATLOG/proto_list_${MACH} \
1910		$PARENT_WS/usr/src/proto_list_${MACH}
1911fi
1912
1913# Update parent proto area if necessary. This is done now
1914# so that the proto area has either DEBUG or non-DEBUG kernels.
1915# Note that this clears out the lock file, so we can dispense with
1916# the variable now.
1917if [ "$U_FLAG" = "y" -a "$build_ok" = "y" ]; then
1918	echo "\n==== Copying proto area to $NIGHTLY_PARENT_ROOT ====\n" | \
1919	    tee -a $LOGFILE >> $mail_msg_file
1920	rm -rf $NIGHTLY_PARENT_ROOT/*
1921	unset Ulockfile
1922	mkdir -p $NIGHTLY_PARENT_ROOT
1923	if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
1924		( cd $ROOT; tar cf - . |
1925		    ( cd $NIGHTLY_PARENT_ROOT;  umask 0; tar xpf - ) ) 2>&1 |
1926		    tee -a $mail_msg_file >> $LOGFILE
1927	fi
1928	if [[ "$MULTI_PROTO" = yes && "$F_FLAG" = n ]]; then
1929		rm -rf $NIGHTLY_PARENT_ROOT-nd/*
1930		mkdir -p $NIGHTLY_PARENT_ROOT-nd
1931		cd $ROOT-nd
1932		( tar cf - . |
1933		    ( cd $NIGHTLY_PARENT_ROOT-nd; umask 0; tar xpf - ) ) 2>&1 |
1934		    tee -a $mail_msg_file >> $LOGFILE
1935	fi
1936	if [ -n "${NIGHTLY_PARENT_TOOLS_ROOT}" ]; then
1937		echo "\n==== Copying tools proto area to $NIGHTLY_PARENT_TOOLS_ROOT ====\n" | \
1938		    tee -a $LOGFILE >> $mail_msg_file
1939		rm -rf $NIGHTLY_PARENT_TOOLS_ROOT/*
1940		mkdir -p $NIGHTLY_PARENT_TOOLS_ROOT
1941		if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
1942			( cd $TOOLS_PROTO; tar cf - . |
1943			    ( cd $NIGHTLY_PARENT_TOOLS_ROOT;
1944			    umask 0; tar xpf - ) ) 2>&1 |
1945			    tee -a $mail_msg_file >> $LOGFILE
1946		fi
1947	fi
1948fi
1949
1950#
1951# ELF verification: ABI (-A) and runtime (-r) checks
1952#
1953if [[ ($build_ok = y) && (($A_FLAG = y) || ($r_FLAG = y)) ]]; then
1954	# Directory ELF-data.$MACH holds the files produced by these tests.
1955	elf_ddir=$SRC/ELF-data.$MACH
1956
1957	# If there is a previous ELF-data backup directory, remove it. Then,
1958	# rotate current ELF-data directory into its place and create a new
1959	# empty directory
1960	rm -rf $elf_ddir.ref
1961	if [[ -d $elf_ddir ]]; then
1962		mv $elf_ddir $elf_ddir.ref
1963	fi
1964	mkdir -p $elf_ddir
1965
1966	# Call find_elf to produce a list of the ELF objects in the proto area.
1967	# This list is passed to check_rtime and interface_check, preventing
1968	# them from separately calling find_elf to do the same work twice.
1969	find_elf -fr $checkroot > $elf_ddir/object_list
1970
1971	if [[ $A_FLAG = y ]]; then
1972	       	echo "\n==== Check versioning and ABI information ====\n"  | \
1973		    tee -a $LOGFILE >> $mail_msg_file
1974
1975		# Produce interface description for the proto. Report errors.
1976		interface_check -o -w $elf_ddir -f object_list \
1977			-i interface -E interface.err
1978		if [[ -s $elf_ddir/interface.err ]]; then
1979			tee -a $LOGFILE < $elf_ddir/interface.err \
1980			    >> $mail_msg_file
1981			build_extras_ok=n
1982		fi
1983
1984		# If ELF_DATA_BASELINE_DIR is defined, compare the new interface
1985		# description file to that from the baseline gate. Issue a
1986		# warning if the baseline is not present, and keep going.
1987		if [[ "$ELF_DATA_BASELINE_DIR" != '' ]]; then
1988			base_ifile="$ELF_DATA_BASELINE_DIR/interface"
1989
1990		       	echo "\n==== Compare versioning and ABI information" \
1991			    "to baseline ====\n"  | \
1992			    tee -a $LOGFILE >> $mail_msg_file
1993		       	echo "Baseline:  $base_ifile\n" >> $LOGFILE
1994
1995			if [[ -f $base_ifile ]]; then
1996				interface_cmp -d -o $base_ifile \
1997				    $elf_ddir/interface > $elf_ddir/interface.cmp
1998				if [[ -s $elf_ddir/interface.cmp ]]; then
1999					echo | tee -a $LOGFILE >> $mail_msg_file
2000					tee -a $LOGFILE < \
2001					    $elf_ddir/interface.cmp \
2002					    >> $mail_msg_file
2003					build_extras_ok=n
2004				fi
2005			else
2006			       	echo "baseline not available. comparison" \
2007                                    "skipped" | \
2008				    tee -a $LOGFILE >> $mail_msg_file
2009			fi
2010
2011		fi
2012	fi
2013
2014	if [[ $r_FLAG = y ]]; then
2015		echo "\n==== Check ELF runtime attributes ====\n" | \
2016		    tee -a $LOGFILE >> $mail_msg_file
2017
2018		# If we're doing a DEBUG build the proto area will be left
2019		# with debuggable objects, thus don't assert -s.
2020		if [[ $D_FLAG = y ]]; then
2021			rtime_sflag=""
2022		else
2023			rtime_sflag="-s"
2024		fi
2025		check_rtime -i -m -v $rtime_sflag -o -w $elf_ddir \
2026			-D object_list  -f object_list -E runtime.err \
2027			-I runtime.attr.raw
2028		if (( $? != 0 )); then
2029			build_extras_ok=n
2030		fi
2031
2032		# check_rtime -I output needs to be sorted in order to
2033		# compare it to that from previous builds.
2034		sort $elf_ddir/runtime.attr.raw > $elf_ddir/runtime.attr
2035		rm $elf_ddir/runtime.attr.raw
2036
2037		# Report errors
2038		if [[ -s $elf_ddir/runtime.err ]]; then
2039			tee -a $LOGFILE < $elf_ddir/runtime.err \
2040				>> $mail_msg_file
2041			build_extras_ok=n
2042		fi
2043
2044		# If there is an ELF-data directory from a previous build,
2045		# then diff the attr files. These files contain information
2046		# about dependencies, versioning, and runpaths. There is some
2047		# overlap with the ABI checking done above, but this also
2048		# flushes out non-ABI interface differences along with the
2049		# other information.
2050		echo "\n==== Diff ELF runtime attributes" \
2051		    "(since last build) ====\n" | \
2052		    tee -a $LOGFILE >> $mail_msg_file >> $mail_msg_file
2053
2054		if [[ -f $elf_ddir.ref/runtime.attr ]]; then
2055			diff $elf_ddir.ref/runtime.attr \
2056				$elf_ddir/runtime.attr \
2057				>> $mail_msg_file
2058		fi
2059	fi
2060
2061	# If -u set, copy contents of ELF-data.$MACH to the parent workspace.
2062	if [[ "$u_FLAG" = "y" ]]; then
2063		p_elf_ddir=$PARENT_WS/usr/src/ELF-data.$MACH
2064
2065		# If parent lacks the ELF-data.$MACH directory, create it
2066		if [[ ! -d $p_elf_ddir ]]; then
2067			staffer mkdir -p $p_elf_ddir
2068		fi
2069
2070		# These files are used asynchronously by other builds for ABI
2071		# verification, as above for the -A option. As such, we require
2072		# the file replacement to be atomic. Copy the data to a temp
2073		# file in the same filesystem and then rename into place.
2074		(
2075			cd $elf_ddir
2076			for elf_dfile in *; do
2077				staffer cp $elf_dfile \
2078				    ${p_elf_ddir}/${elf_dfile}.new
2079				staffer mv -f ${p_elf_ddir}/${elf_dfile}.new \
2080				    ${p_elf_ddir}/${elf_dfile}
2081			done
2082		)
2083	fi
2084fi
2085
2086# DEBUG lint of kernel begins
2087
2088if [ "$i_CMD_LINE_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
2089	if [ "$LINTDIRS" = "" ]; then
2090		# LINTDIRS="$SRC/uts y $SRC/stand y $SRC/psm y"
2091		LINTDIRS="$SRC y"
2092	fi
2093	set $LINTDIRS
2094	while [ $# -gt 0 ]; do
2095		dolint $1 $2; shift; shift
2096	done
2097else
2098	echo "\n==== No '$MAKE lint' ====\n" >> $LOGFILE
2099fi
2100
2101# "make check" begins
2102
2103if [ "$i_CMD_LINE_FLAG" = "n" -a "$C_FLAG" = "y" ]; then
2104	# remove old check.out
2105	rm -f $SRC/check.out
2106
2107	rm -f $SRC/check-${MACH}.out
2108	cd $SRC
2109	$MAKE -ek check ROOT="$checkroot" 2>&1 | tee -a $SRC/check-${MACH}.out \
2110	    >> $LOGFILE
2111	echo "\n==== cstyle/hdrchk errors ====\n" >> $mail_msg_file
2112
2113	grep ":" $SRC/check-${MACH}.out |
2114		egrep -v "Ignoring unknown host" | \
2115		sort | uniq | tee $TMPDIR/check_errors >> $mail_msg_file
2116
2117	if [[ -s $TMPDIR/check_errors ]]; then
2118		build_extras_ok=n
2119	fi
2120else
2121	echo "\n==== No '$MAKE check' ====\n" >> $LOGFILE
2122fi
2123
2124echo "\n==== Find core files ====\n" | \
2125    tee -a $LOGFILE >> $mail_msg_file
2126
2127find $abssrcdirs -name core -a -type f -exec file {} \; | \
2128	tee -a $LOGFILE >> $mail_msg_file
2129
2130if [ "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
2131	echo "\n==== Diff unreferenced files (since last build) ====\n" \
2132	    | tee -a $LOGFILE >>$mail_msg_file
2133	rm -f $SRC/unref-${MACH}.ref
2134	if [ -f $SRC/unref-${MACH}.out ]; then
2135		mv $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
2136	fi
2137
2138	findunref -S $SCM_TYPE -t $SRC/.build.tstamp -s usr $CODEMGR_WS \
2139	    ${TOOLS}/findunref/exception_list 2>> $mail_msg_file | \
2140	    sort > $SRC/unref-${MACH}.out
2141
2142	if [ ! -f $SRC/unref-${MACH}.ref ]; then
2143		cp $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
2144	fi
2145
2146	diff $SRC/unref-${MACH}.ref $SRC/unref-${MACH}.out >>$mail_msg_file
2147fi
2148
2149# Verify that the usual lists of files, such as exception lists,
2150# contain only valid references to files.  If the build has failed,
2151# then don't check the proto area.
2152CHECK_PATHS=${CHECK_PATHS:-y}
2153if [ "$CHECK_PATHS" = y -a "$N_FLAG" != y ]; then
2154	echo "\n==== Check lists of files ====\n" | tee -a $LOGFILE \
2155		>>$mail_msg_file
2156	arg=-b
2157	[ "$build_ok" = y ] && arg=
2158	checkpaths $arg $checkroot > $SRC/checkpaths.out 2>&1
2159	if [[ -s $SRC/checkpaths.out ]]; then
2160		tee -a $LOGFILE < $SRC/checkpaths.out >> $mail_msg_file
2161		build_extras_ok=n
2162	fi
2163fi
2164
2165if [ "$M_FLAG" != "y" -a "$build_ok" = y ]; then
2166	echo "\n==== Impact on file permissions ====\n" \
2167		>> $mail_msg_file
2168
2169	abspkg=
2170	for d in $abssrcdirs; do
2171		if [ -d "$d/pkg" ]; then
2172			abspkg="$abspkg $d"
2173		fi
2174	done
2175
2176	if [ -n "$abspkg" ]; then
2177		for d in "$abspkg"; do
2178			( cd $d/pkg ; $MAKE -e pmodes ) >> $mail_msg_file
2179		done
2180	fi
2181fi
2182
2183if [ "$w_FLAG" = "y" -a "$build_ok" = "y" ]; then
2184	if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
2185		do_wsdiff DEBUG $ROOT.prev $ROOT
2186	fi
2187
2188	if [[ "$MULTI_PROTO" = yes && "$F_FLAG" = n ]]; then
2189		do_wsdiff non-DEBUG $ROOT-nd.prev $ROOT-nd
2190	fi
2191fi
2192
2193END_DATE=`date`
2194echo "==== Nightly $maketype build completed: $END_DATE ====" | \
2195    tee -a $LOGFILE >> $build_time_file
2196
2197typeset -i10 hours
2198typeset -Z2 minutes
2199typeset -Z2 seconds
2200
2201elapsed_time=$SECONDS
2202((hours = elapsed_time / 3600 ))
2203((minutes = elapsed_time / 60  % 60))
2204((seconds = elapsed_time % 60))
2205
2206echo "\n==== Total build time ====" | \
2207    tee -a $LOGFILE >> $build_time_file
2208echo "\nreal    ${hours}:${minutes}:${seconds}" | \
2209    tee -a $LOGFILE >> $build_time_file
2210
2211if [ "$u_FLAG" = "y" -a "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
2212	staffer cp ${SRC}/unref-${MACH}.out $PARENT_WS/usr/src/
2213
2214	#
2215	# Produce a master list of unreferenced files -- ideally, we'd
2216	# generate the master just once after all of the nightlies
2217	# have finished, but there's no simple way to know when that
2218	# will be.  Instead, we assume that we're the last nightly to
2219	# finish and merge all of the unref-${MACH}.out files in
2220	# $PARENT_WS/usr/src/.  If we are in fact the final ${MACH} to
2221	# finish, then this file will be the authoritative master
2222	# list.  Otherwise, another ${MACH}'s nightly will eventually
2223	# overwrite ours with its own master, but in the meantime our
2224	# temporary "master" will be no worse than any older master
2225	# which was already on the parent.
2226	#
2227
2228	set -- $PARENT_WS/usr/src/unref-*.out
2229	cp "$1" ${TMPDIR}/unref.merge
2230	shift
2231
2232	for unreffile; do
2233		comm -12 ${TMPDIR}/unref.merge "$unreffile" > ${TMPDIR}/unref.$$
2234		mv ${TMPDIR}/unref.$$ ${TMPDIR}/unref.merge
2235	done
2236
2237	staffer cp ${TMPDIR}/unref.merge $PARENT_WS/usr/src/unrefmaster.out
2238fi
2239
2240#
2241# All done save for the sweeping up.
2242# (whichever exit we hit here will trigger the "cleanup" trap which
2243# optionally sends mail on completion).
2244#
2245if [[ "$build_ok" == "y" ]]; then
2246	if [[ "$W_FLAG" == "y" || "$build_extras_ok" == "y" ]]; then
2247		exit 0
2248	fi
2249fi
2250
2251exit 1
2252